<?php

// fwiki 1.0b (c) http://galupki.de/php.html#fwiki GPL, ergaenzende lizenzhinweise auf http://galupki.de/kontakt/
// siehe unbedingt auch Bemerkungen zu Beginn von index.php


// ++++++++ NO CHANGES BELOW HERE ! ++++++++
//       (unless you are a developer)




// redirect page
function redirectpage( $file )
{
  header("Location: index.php?wiki=".basename($file) );
}




function dataspace () {

  global $data_dir, $lock_dir;

  $space = 0;

  $handle = opendir($data_dir);
    while ($file = readdir ($handle))
    {
        if (eregi("^\.{1,2}$",$file))
        {
            continue;
        }

        if (!is_dir("$data_dir/$file")) {
            $space += filesize("$data_dir/$file");
        }
    }
    closedir($handle);

    return $space;

} // end function dataspace



function file_locked ($file) {
  global $lock_dir;
  if ( file_exists($lock_dir."/".$file.".lock")) {
     return true;
  }  else {
     return false;
  }
} // end function is_locked_file



function file_global_locked ($file) {
  global $locked;
     if ( in_array ( "ALLESEITEN", $locked)       // um ALLE Wikiseiten zu sperren!
        OR in_array ( $file, $locked) ) {         // oder halt eine Auswahl von Seitennamen
        return true;
     }  else {
        return false;
     }
} // end function is_global_locked_file



function lock_file ($file) {
  global $lock_dir;
  if (trim($file!="")) {
     touch($lock_dir."/".$file.".lock");
  }
} // end function lock_file


function unlock_file ($file) {
  global $lock_dir;
  if (trim($file!="")) {
     unlink($lock_dir."/".$file.".lock");
  }
} // end function unlock_file


function lock_list () {

  global $wiki_get;

  global $img_locked, $img_unlocked, $img_editorlock, $img_dir;
  global $lock_dir, $data_dir;
  global $lastpage;

  $content =  $img_locked . " zum sperren einer WikiPage<br />\n";
  $content .= $img_unlocked." zum entsperren einer WikiPage<br />\n";
  $content .= "&nbsp;<br />gegen versehentliches berschreiben anklicken oder zurck zu <a href=\"index.php?wiki=$lastpage\">" . $lastpage . "</a>\n";



// Datei zu lschen?
  $delete = basename(trim($_REQUEST["delete"]));
  if ( $delete!=""
       AND is_file("$data_dir/$delete")
       AND filesize("$data_dir/$delete")<4
       AND !file_locked($delete)
       AND !file_global_locked($delete) ) {

     if ( unlink("$data_dir/$delete") ) {
        $content .= "<h4>Wikiseite $delete wurde gelscht!</h4>";
     }  else {
        $content .= "<h4>Fehler: Wikiseite $delete konnte nicht gelscht werden!</h4>";
     }
  }



  $content .= "<p>\n";

  $handle = opendir($data_dir);
  while( $newfile = readdir($handle) ) {
     if (preg_match("/([A-Z][a-z0-9]+){2,}/", $newfile) ) {
        $allpages[] = $newfile;
     }
  }
  sort($allpages);
  foreach( $allpages as $page ) {

     $is_loeschen_ok = true;

     $content .= "<a href=\"index.php?wiki=LockList&amp;lockliste=liste&amp;lastpage=$lastpage";
     if (file_locked($page)) {
        $content .= "&amp;unlock=$page\">" . $img_unlocked;
        $is_loeschen_ok = false;
     }  else {
        $content .= "&amp;lock=$page\">" . $img_locked;
     }
     $content .= " </a> $page ";
     if ( file_global_locked($page) ) {
        $content .= " global:<img src=\"".$img_dir."unlock.gif\" width=\"15\" height=\"15\" border=\"0\" title=\"locked\" alt=\"locked\" />";
        $is_loeschen_ok = false;
     }
     if ( file_exists("$lock_dir/$page.edit") ) {
        $content .= " $img_editorlock ";
        $is_loeschen_ok = false;
     }

     if ($is_loeschen_ok==true
         AND filesize("$data_dir/$page")<4) {
         $content .= " &nbsp; <a href=\"index.php?wiki=LockList&amp;delete=$page&amp;lastpage=$lastpage\">[Diese Datei lschen]</a> &nbsp;";
     }


     $content .= "<br />\n";
  }

  $content .= "</p>\n";

  return $content;

} // end function lock_list



function upload_prot( $action, $dateiname, $groesse ) {
 global $protfile;

 $action    = str_replace(";", ",", $action);
 $dateiname = str_replace(";", ",", $dateiname);
 $groesse   = str_replace(";", ",", $groesse);

// Append Satz an Datei
 $dh = fopen( $protfile, "ab" );
 fputs($dh,
       $action
       . ";" . $_SERVER["REMOTE_ADDR"]
       . ";" . $_SERVER["REMOTE_USER"]
       . ";" . date("l d.m.Y H:i")
       . ";" . $dateiname
       . ";" . $groesse
       . "\r\n");
 fclose($dh);


} // end function upload_prot



function upload_show_dir($dir, $pos=2) {

global $spaceMB;
global $spaceMaxMB;
global $protfile;
global $erweiterungen;
global $upload_dir, $img_dir, $data_dir;
global $page_uploadmanager;


 $content  = "";
 $content .= "<h3>Folgende Dateien befinden sich derzeit im upload-Bereich:</h3>\n";


    if($pos == 2)
    {
     $content .= "<pre>\n";
    }

    $handle = @opendir($dir);
    while ($file = @readdir ($handle))
    {
        if (eregi("^\.{1,2}$",$file))
        {
            continue;
        }

        if(is_dir($dir.$file))
        {
//          $content .= sprintf ("% ".$pos."s <b>%s</b>\n", " ", $file);
//          $content .= show_dir($dir.$file."/", $pos + 3);
        }
        else
        {
            $tmp = "";
//          $tmp = sprintf ("% ".$pos."s ", " ");
            if ($dir.$file!=$protfile
                AND !file_global_locked($page_uploadmanager."Upload")) {
               $datdat = filemtime($dir.$file);
               $modified = " ".date("d.m.Y H:i:s", $datdat)." ";
               $actday = time() - 86400;
               $actwoche = time() - 86400*7;
               $actmonat = time() - 86400*30;
               $bild = "transparent.gif";
               if ($datdat<$actmonat) {
                  $klasse = "steinalt";
               }  elseif ($datdat<$actwoche) {
                  $klasse = "alt";
               }  else {
                  $klasse = "aktuell";
               }
               if ($datdat>$actday) {
                  $bild = "animation.gif";
               }
               $marker = "<span class=\"$klasse\"><img src=\"".$img_dir."$bild\" height=\"15\" width=\"15\" border=\"0\" alt=\"$klasse\" title=\"$klasse\" /></span> ";
               $is_csvfile = false;
               if ( substr($file,0,7)=="csvedit" ) {                              // ist/war eine Datendatei
                  $check = explode(".", $file);                                   // csvedit.FileName.csv
                  if ( file_exists("$data_dir/".$check[1]) ) {
                     $is_csvfile = true;
                  }
               }
               if ( $is_csvfile==false ) {
                  $tmp .= "$marker<a href=\"index.php?wiki=UploadManager&amp;upldel=$file\"><img src=\"".$img_dir."loeschen.gif\" alt=\"delete $file\" title=\"delete $file\" /></a> ";
               }  else {
                  $tmp .= "$marker<img src=\"".$img_dir."zeigen.gif\" alt=\"csv-Datendatei\" title=\"CSV-Datendatei von ".$check[1]."\" /> ";
               }
            }  else {
               $tmp .= "$marker<img src=\"".$img_dir."zeigen.gif\" alt=\"Protokolldatei\" title=\"Protokolldatei einsehen\" /> ";
            }
            $tmp .= " <a href=\"$upload_dir/" . $file . "\">$file</a> <span class=\"small\">$modified</span> ";
            $spaceMB += filesize($dir.$file);
            $tmp .= round(filesize($dir.$file)/1000,0) . "KB";
            $allfiles[] = $tmp; // sammeln
        }
    }
    @closedir($handle);

    if($pos == 2)
    {
      if (count($allfiles)>0) {
         natcasesort ($allfiles);
         foreach ($allfiles as $zeile) {
             $content .= $zeile."\n";
         }
      }
      $content .= "</pre>\n";
    }


 $rest = $spaceMaxMB - $spaceMB;

 $content .= "Alter der Dateien: <span class=\"aktuell\"><img src=\"".$img_dir."animation.gif\" height=\"15\" width=\"15\" border=\"0\" alt=\"ganz frisch\" title=\"ganz frisch\" /></span> keine 24h alt,  \n";
 $content .= "<span class=\"aktuell\"><img src=\"".$img_dir."transparent.gif\" height=\"15\" width=\"15\" border=\"0\" alt=\"aktuell\" title=\"aktuell\" /></span> aus der aktuellen Woche,  \n";
 $content .= "<span class=\"alt\"><img src=\"".$img_dir."transparent.gif\" height=\"15\" width=\"15\" border=\"0\" alt=\"alt\" title=\"alt\" /></span> aus dem aktuellen Monat,  \n";
 $content .= "<span class=\"steinalt\"><img src=\"".$img_dir."transparent.gif\" height=\"15\" width=\"15\" border=\"0\" alt=\"steinalt\" title=\"steinalt\" /></span> lter als 30 Tage.<br />\n";

 $content .= "&nbsp;<br />Frei: " . round($rest/1000000,3) . " MB von reservierten " . $spaceMaxMB/1000000 .  " MB<br />\n";

 $content .= "Erlaubte Dateitypen: <span class=\"small\">";
 foreach ($erweiterungen as $x) {
    $content .= "*.$x ";
 }
 $content .= "</span>\n";


 return $content;

} // end function upload_show_dir





function upload_delete($file) {
// loesche datei im uploadpfad
global $incoming,
       $protfile,
       $page_uploadmanager;


 $file = basename($file);

   if ( $file==""
        OR !file_exists($incoming.$file)
        OR file_global_locked($page_uploadmanager."Upload")  // besonderheit!!!
        OR $incoming.$file==$protfile) {
        return;
   }

   $size = round(filesize($incoming.$file)/1000,3);

   if ( unlink($incoming.$file) ) {
      upload_prot( "delete", basename($incoming.$file), $size."KB" );
   }
} // end function upload_delete




function upload_form() {

  global $wiki_get;
  global $name;
  global $data_dir;
  global $spaceMaxMB;
  global $spaceMB;
  global $erweiterungen;
  global $incoming;
  global $protfile;



  $name = basename($name);

  $formular = "<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php\">\n<input type=\"hidden\" name=\"$wiki_get\" value=\"$name\" />"
            . "<table id=\"find\">\n<tr>\n<td><b>Upload</b> Datei</td>\n<td>"
            . "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$spaceMaxMB\" />"
            . "<input type=\"file\" name=\"probe\" /></td>\n</tr>"
            . "<tr>\n<td colspan=\"2\"><input type=\"submit\" value=\"upload\" /></td>\n</tr>\n</table>\n</form>\n";


  if (
      isset($_FILES['probe']) and !$_FILES['probe']['error']
      and $spaceMB <= $spaceMaxMB                                // :)
     ) {


    if ($_FILES['probe']['error']!=0) {
//     $formular .= "<br />tempname   " . $_FILES['probe']['tmp_name'];
       $formular .= "<br />Name       " . $_FILES['probe']['name'];
       $formular .= "<br />Bytes      " . $_FILES['probe']['size'];
       $formular .= "<br />type       " . $_FILES['probe']['type'];
       $formular .= "<br />error      " . $_FILES['probe']['error'];
       $formular .= "<br />&nbsp;";
    }

    $rest = $spaceMaxMB - $spaceMB;

    $path_parts = pathinfo($_FILES['probe']['name']);
    if (in_array (strtolower($path_parts["extension"]), $erweiterungen)) {
       $sw_erweiterung = true;
    }  else {
       $sw_erweiterung = false;
    }

    if (file_exists($incoming . basename($_FILES['probe']['name']))) {
       $formular .= "\nDatei existierte schon und wurde berschrieben!";
       $rest = $rest + filesize($incoming . basename($_FILES['probe']['name']));
    }

    $rest = $rest - filesize( $_FILES['probe']['tmp_name'] );

    if ( ($rest+$spaceMaxMB*0.1) >= 0
         AND $sw_erweiterung==true ) {
       move_uploaded_file($_FILES['probe']['tmp_name'], $incoming . basename($_FILES['probe']['name']));
       chmod ($incoming . basename($_FILES['probe']['name']) , 0644);

       $formular .= "\nDatei " . basename($_FILES['probe']['name']) . " wurde angelegt.";

       $size = round(filesize($incoming . basename($_FILES['probe']['name']))/1000,3);

       upload_prot( "upload", basename($_FILES['probe']['name']), $size."KB" );

    }  else {
       $formular .= "\n<h2>FEHLER</h2>Es ist nicht (mehr) gengend <strong>Platz</strong> vorgesehen (frei: $rest Bytes ),";
       $formular .= "\n<br />die <strong>Dateiendung</strong> ist nicht in der Liste der erlaubten Dateitypen aufgefhrt,";
       $formular .= "\nexistiert nicht auf dem Client, oder das Script arbeitet nicht korrekt.";
    }

  }

  return $formular;


} // end function upload_form



function import_pages ($suchmuster) {
// holt Seiten in den Wiki wenn sie noch nicht existieren

  global $import_dir, $incoming, $protfile;
  global $data_dir;

  $content = "";

  $handle = opendir($import_dir);
  while( $newfile = readdir($handle) ) {
     if (preg_match("/([A-Z][a-z0-9]+){2,}\.wiki$/", $newfile) ) {
        if ( preg_match($suchmuster, $newfile) ) {
           $allpages[] = substr($newfile, 0, strlen($newfile)-5);       // wiki. abschneiden
        }
     }
  }

  if (count($allpages)==0) return;

  sort($allpages);

  foreach( $allpages as $page ) {
     if (!file_exists($data_dir."/".$page)) {
        if ( copy( $import_dir.$page.".wiki", $data_dir."/".$page ) ) {
           $content .= "$page.wiki -> wurde importiert nach $page<br />";
           unlink($import_dir.$page.".wiki");
           if ($incoming==$import_dir) {
              upload_prot( "wikiimport (delete)", "$page.wiki", " " );
           }
        }
     }  else {
        $content .= "$page.wiki -> $page existiert bereits, nicht importiert.<br />";
     }
  }

  return $content;

} // end function import_pages


function export_pages ($suchmuster, $switchbulk) {

  global $export_dir, $incoming, $protfile;
  global $data_dir;

  $content = "";

  $handle = opendir($data_dir);
  while( $newfile = readdir($handle) ) {
     if (preg_match("/([A-Z][a-z0-9]+){2,}/", $newfile) ) {
        if ( preg_match($suchmuster, $newfile) ) {
           $allpages[] = $newfile;
        }
     }
  }

  if (count($allpages)==0) return;

  sort($allpages);

  foreach( $allpages as $page ) {
     if (!file_exists($export_dir."$page.wiki")) {
        copy( $data_dir."/".$page, $export_dir."$page.wiki" );
        $content .= "$page -> wurde exportiert nach $page.wiki<br />";
        if ($incoming==$export_dir) {
           upload_prot( "wikiexport", "$page.wiki", " " );
        }
     }  else {
        $content .= "$page -> $page.wiki existiert bereits, nicht exportiert.<br />";
     }
  }

  return $content . make_bulk_file($suchmuster, $switchbulk);

} // end function export_pages



function import_bulkfile($bulkfilename) {
// erzeugt aus allen *.wiki-Dateien einer Sammeldatei
// einzelne Dateien


  function write_wikifile($datei, $inhalt, $bulkfilename) {
    global $incoming, $import_dir, $protfile;


    $msg = "";

    if ( file_exists($datei) ) {
       $msg .= basename($datei) . " existiert bereits und wird berschrieben!<br />\n";
    }

    $whandle = fopen($datei, "a+b");
    if (fwrite($whandle, $inhalt)) {
       $msg .= basename($datei) . " wurde aus bulkfile $bulkfilename extrahiert.<br />\n";
        if ($incoming==$import_dir) {
           upload_prot( "$bulkfilename ->", basename($datei), " " );
        }
    }  else {
       $msg .= "Fehler beim schreiben von " . basename($datei) . "<br />\n";
    }
    fclose($whandle);

    return $msg;

  } // end function write_wikifile



  global $import_dir, $incoming, $protfile;
  $bulktrenner  = "----------wikibulkfile----------\r\n";

  $content = "";

  $bulkfilename = basename($bulkfilename);
  if ( !file_exists($import_dir.$bulkfilename) ) {
     return "<strong>Bulkfile $bulkfilename existiert nicht</strong><br />";
  }


  $handle = fopen($import_dir.$bulkfilename, "r");

  $dateiname = "";
  $dateiinhalt = "";

  while( !feof($handle) ) {
     $buffer = fgets($handle, 4096);
     if ( trim($buffer)==trim($bulktrenner) ) {                // neue eingebettete Datei beginnt
        $newfilename = basename(trim( fgets($handle, 4096)));
        if ( $dateiname!=""
             AND $dateiname!=$newfilename
             AND preg_match("/([A-Z][a-z0-9]+){2,}\.wiki$/", $dateiname) ) {
           $content .= write_wikifile($import_dir.$dateiname, $dateiinhalt, $bulkfilename);
        }
        $dateiname   = $newfilename;                           // und heisst
        $dateiinhalt = "";
     }  else {
         $dateiinhalt .= $buffer;                              // eine weitere Zeile anhaengen
     }
  }

  // letzte Datei nachholen
  if ( $dateiname!=""
       AND preg_match("/([A-Z][a-z0-9]+){2,}\.wiki$/", $dateiname) ) {
     $content .= write_wikifile($import_dir.$dateiname, $dateiinhalt, $bulkfilename);
  }

  fclose($handle);


  return $content;


} // end function import_bulkfile



function make_bulk_file($suchmuster, $switchbulkonly) {
// erzeugt aus allen *.wiki-Dateien im Exportpfad eine "Sammeldatei"
// bzw. haengt dort die einzelnen Files einfach dran

  global $export_dir, $incoming, $protfile;

  $bulktrenner  = "----------wikibulkfile----------\r\n";
  $bulkfilename = "export.wikibulk";

  $content = "";

  $handle = opendir($export_dir);
  while( $newfile = readdir($handle) ) {
     if (preg_match("/([A-Z][a-z0-9]+){2,}\.wiki$/", $newfile) ) {
        if ( preg_match($suchmuster, $newfile) ) {
           $allpages[] = $newfile;
        }
     }
  }

  if (count($allpages)==0) return;

  sort($allpages);

  $outf = fopen($export_dir.$bulkfilename, "a+b");

  foreach( $allpages as $page ) {
     $tmpfile = file_get_contents($export_dir.$page);
     if ( substr($tmpfile, -1, 1)!="\n" ) {
        $tmpfile .= "\r\n";
        $content .= "$page -> Zeilenwechsel angefgt ";
     }
     if ( fwrite( $outf, $bulktrenner.$page."\r\n".$tmpfile)) {
        $content .= "$page -> nach $bulkfilename migriert";
        if ( $switchbulkonly=="yes" ) {
           unlink($export_dir.$page);
           $content .= " und anschliessend hier gelscht<br />\n";
        }  else {
           $content .= "<br />\n";
        }
        if ($incoming==$import_dir) {
           upload_prot( "-> $bulkfilename $switchbulkonly", $page, " " );
        }
     }
  }

  fclose($outf);

  return $content;

} // end function make_bulk_file




function import_export_form() {

  global $wiki_get;
  global $name;

  $name = basename($name);

  $suchmimp = trim($_POST["suchmimp"]);
  $suchmexp = trim($_POST["suchmexp"]);
  $bulkfile = trim($_POST["bulkfile"]);
  $expbulk  = trim($_POST["expbulk"]);
  $Submit  = $_POST["Submit"];

  $formular = "<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php\">\n<input type=\"hidden\" name=\"$wiki_get\" value=\"$name\" />"
            . "<table id=\"find\">\n"
            . "<tr>\n<td>entpacke bulkfile</td>\n<td><input type=\"text\" name=\"bulkfile\" size=\"50\" maxlength=\"250\" value=\"$bulkfile\" /></td>\n</tr>"
            . "<tr>\n<td>Suchmuster IMPORT</td>\n<td><input type=\"text\" name=\"suchmimp\" size=\"50\" maxlength=\"250\" value=\"$suchmimp\" /></td>\n</tr>"
            . "<tr>\n<td>Suchmuster EXPORT</td>\n<td><input type=\"text\" name=\"suchmexp\" size=\"50\" maxlength=\"250\"  value=\"$suchmexp\" /></td>\n</tr>"
            . "<tr>\n<td> </td>\n<td><input type=\"checkbox\" name=\"expbulk\" value=\"yes\" /> *.wiki Datei im UploadManager lschen nach migrieren ins bulkfile</td>\n</tr>"
            . "<tr>\n<td colspan=\"2\"><input type=\"submit\" value=\"Submit\" name=\"Submit\" /></td>\n</tr>\n</table>\n</form>\n";


  $content = "";

  if ( $Submit=="Submit"
       AND !file_global_locked(basename($name)."ImpExp") ) {

     if ( trim(basename($bulkfile))!="" ) {
        $content .= "<h3>Extrahieren von $bulkfile</h3>\n";
        $content .= import_bulkfile( trim(basename($bulkfile)) );
     }
     if ( trim($suchmimp)!="" ) {
        $content .= "<h3>Import</h3>\n";
        $content .= import_pages("/$suchmimp/");
     }  else {
        $content .= "Nichts zu importieren.<br />\n";
     }
     if ( trim($suchmexp)!="" ) {
        $content .= "<h3>Export</h3>";
        $content .= export_pages("/$suchmexp/", $expbulk);
     }  else {
        $content .= "Nichts zu exportieren.<br />\n";
     }
  }

  return $formular.$content;

} // end function import_export_form




function chat_status() {

  global $name;
  global $lock_dir, $data_dir;
  global $chatzeit; // time until meta-refresh in sec

  $name = basename($name);

  $chat_passiv = $chatzeit * 5;  // auto-logoff-time
  if ($chat_passiv<60) {
     $chat_passiv = 5*60;        // ne, min. 5 Minuten
  }

  $handle = opendir($lock_dir);
    while( $newfile = readdir($handle) ) {
        $namepos = strpos($newfile, ".chatter.");  // someone there?
        if( !$namepos===false ) {
            $lasttime = filemtime("$lock_dir/$newfile");
            $actualtime = time();
            if ( $actualtime - $lasttime <= $chat_passiv ) {
               $teilnehmer = str_replace( $name.".", "", str_replace(".chatter", "", $newfile) );
               $testfile   = explode(".", $teilnehmer, 2);
               if ( trim($testfile[0])!=""
                  AND file_exists("$data_dir/".$testfile[0]) ) {
                  $teilnehmer = "<a href=\"index.php?wiki=".$testfile[0]."\">".$testfile[0]."</a> <span class=\"small\">$testfile[1]</span>";
               }
               $allpages[] = $teilnehmer;
            }  elseif ( !file_global_locked("Chat") ) { // besonderheit!!!
               unlink("$lock_dir/$newfile"); // logoff, maybee gone to bed
            }
        }
    }

    if (count($allpages)==0) {
       return "";
    }

    sort($allpages);
    $content = "";

    foreach( $allpages as $user ) {
        $content .= "&nbsp;" . $user;
    }

    return $content;

}  // end function chat_status



function chat_user( $chat, $chatmsg ) {

  global $name;
  global $lock_dir;
  $name = basename($name);

  if ( $chat==""
     OR file_global_locked("Chat") ) { // besonderheit!!!
     return;
  }

  if ( $chatmsg!="logoff" ) {
     touch("$lock_dir/$name" . ".chatter.$chat");  // logon oder neue Nachricht
  }  else {
     unlink("$lock_dir/$name" . ".chatter.$chat"); // logoff
  }

}  // end function chatuser


function chat_form() {

  global $wiki_get;
  global $name;
  global $data_dir;
  global $chatter, $chatzeit;

  $name = basename($name);

  $chatter = trim($chatter);
  if ( $chatter=="" ) {
     $chatter = "nobody";
  }
  $chatmsg = trim($_POST["chatmsg"]);
  $Submit  = $_POST["Submit"];

  $formular = "<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php\">\n<input type=\"hidden\" name=\"$wiki_get\" value=\"$name\" />"
            . "<table id=\"find\">\n<tr>\n<td><b>Chatter</b></td>\n<td><input type=\"text\" name=\"chatter\" size=\"6\" maxlength=\"30\" value=\"$chatter\" /></td>\n</tr>"
            . "<tr>\n<td>Nachricht</td>\n<td><input type=\"text\" name=\"chatmsg\" size=\"55\" maxlength=\"250\"/></td>\n</tr>"
            . "<tr>\n<td colspan=\"2\"><input type=\"submit\" value=\"Submit\" name=\"Submit\" /> <span class=\"small\">oder meta-refresh nach $chatzeit sek., CLEAR lscht alle Ausgabezeilen</span></td>\n</tr>\n</table>\n</form>\n";


// kommt/geht/bleibt:
  if ( $Submit=="Submit" ) {
     chat_user($chatter, $chatmsg);
  }

  if ( $Submit=="Submit"
       AND $chatmsg!="" ) {

     $newcontent = "";
     $chatlines = file("$data_dir/$name");
     foreach ($chatlines as $key => $msg) {
        if ( trim($msg)=="<chat>" ) {
           $chatlines[$key] = "<chat>" . "\r\n"
                            . $chatmsg
                            . " ##($chatter) " . date("H:i:s d.m.Y") . "##"
                            . "\r\n"; // neue Zeile an den Anfang
        }
        $newcontent .= $chatlines[$key];
        if ( $chatmsg=="CLEAR" ) {          // besonderheit!!!
           break;
        }
     }
    if ( !file_global_locked("Chat") ) { // besonderheit!!!
       $handle = fopen("$data_dir/$name", "w");
       fwrite($handle, $newcontent);
       fclose($handle);
    }
  }

  return $formular;

} // end function chat_form



function edit_locked() {
// legt lock an oder erneuert ihn

  global $name;
  global $lock_dir;
  global $editzeit;     // time until meta-refresh in sec
  global $lockstring;

  $switch = false;

  $testname = basename($name);
  if ($testname=="") return $switch;

  $edit_passiv = $editzeit;  // auto-logoff-time
  if ($edit_passiv<60) {
     $edit_passiv = 5*60;    // ne, min. 5 Minuten
  }

  if ( file_exists("$lock_dir/$testname.edit") ) {
     // lockfile exists
     $lasttime = filemtime("$lock_dir/$testname.edit");
     $actualtime = time();
     if ( $actualtime - $lasttime <= $edit_passiv ) {
        // file is locked
        $switch = true;
        $lockstring .= " &nbsp;<strong>Text wird bereits editiert.</strong>&nbsp; ";
     }  else {
        // file is locked, but lock timed out
        touch("$lock_dir/$testname.edit");
     }
  }  else  {
     // new lock
     touch("$lock_dir/$testname.edit");
  }

  return $switch;

}  // end function edit_lock



function edit_unlock() {

  global $name;
  global $lock_dir;


  $testname = basename($name);
  if ($testname=="") return;

  if (file_exists("$lock_dir/$testname.edit")) {
     unlink("$lock_dir/$testname.edit");
  }


}  // end function edit_unlock




// *** old original stuff ************************************************************************************


// some specials
function findpage() {
    global $wiki_get;
    global $name;
    global $data_dir;
    $name = basename($name);
    $content = "";
    $formular = "<form method=\"get\" action=\"index.php\">\n<input type=\"hidden\" name=\"$wiki_get\" value=\"$name\" /><table id=\"find\">\n<tr>\n<td>Look for page name</td>\n<td><input type=\"text\" name=\"PageName\" /></td>\n</tr><tr>\n<td>or page content</td>\n<td><input type=\"text\" name=\"PageContent\" /></td>\n</tr><tr>\n<td colspan=\"2\"><input type=\"submit\" value=\"search\" /></td>\n</tr>\n</table>\n</form>\n";
    // get all existant pages from the directory
    $handle = opendir("$data_dir");
    while( $newdir = readdir($handle) )
        if(preg_match("/([A-Z][a-z0-9]+){2,}/",$newdir) )
            $allpages[] = $newdir;
    // look for matching page names
    if( $_GET["PageName"] != "" ) {
        $pagename = $_GET["PageName"];
        $content .= "<h3>Suche nach Seitennamen $pagename</h3>\n<ul>\n";
        foreach ($allpages as $page)
            if (preg_match("/$pagename/i",$page) )
                $content .= "<li><a href=\"index.php?$wiki_get=$page\">$page</a></li>\n";
            $content .= "</ul>\n";
    }
    // Look for matching page content
    if ( $_GET["PageContent"] != "" ) {
        $pagecontent = $_GET["PageContent"];
        $content .= "<h3>Suche nach Seiteninhalt $pagecontent</h3>\n<ul>\n";
        foreach ($allpages as $page) {
            $current = implode( "", file("$data_dir/$page") );
            if (preg_match("/$pagecontent/i",$current) )
                $content .= "<li><a href=\"index.php?$wiki_get=$page\">$page</a></li>\n";
        }
        $content .= "</ul>\n";
    }
    if( $content == "" )
        $content = $formular;
    return $content;
}

function recentchanges() {
    global $data_dir;
    global $timezone;
    global $wiki_get;
    $content = "";
    $handle = opendir($data_dir);
    $allpages = array();
    while( $newfile = readdir($handle) )
        if(preg_match("/([A-Z][a-z0-9]+){2,}/",$newfile) )
            $allpages[] = $newfile;
    $max_pages = sizeof($allpages) / 3;
    if( $max_pages < 30 )
        $max_pages = 30;
    $counter = 0;
    $date = mktime(12,0,0,date('m'),date('d'));
    $day = 0;
    while( $counter < $max_pages && $day < 40 ) {
        $today = array();
        foreach( $allpages as $page ) {
            $filetime = filemtime("$data_dir/$page");
            if( (($filetime + 43198) > $date) && (($filetime - 43199) < $date) )
                $today[] = $page;
        }
        if( sizeof($today) > 0 ) {
            $content .= "<h3>".date("d.m.Y",$date)."</h3>\n<ul>\n";
            foreach( $today as $page )
                $content .= "<li><a href=\"index.php?$wiki_get=$page\">$page</a> (".date("G:i", filemtime("$data_dir/$page")+(3600*$timezone) ).")</li>";
            $content .= "</ul>\n";
        }
        $counter += sizeof($today);
        $date -= 86400;
        $day += 1;
    }
    $content .= "</ul>\n";
    return $content;
}


// galupki modified (index...)
function allpages() {
    global $data_dir;
    global $wiki_get;

    // list all existant pages
    $content = "";
    $handle = opendir($data_dir);
    while( $newfile = readdir($handle) )
        if(preg_match("/([A-Z][a-z0-9]+){2,}/",$newfile) )
            $allpages[] = $newfile;
    sort($allpages);
    $gruppe="";
    foreach( $allpages as $page ) {
        $neuegruppe = substr($page,0,1);
        if ($gruppe!=$neuegruppe) {
           $gruppe = $neuegruppe;
           $index[$gruppe] += 1;
           $content .= "<br /><span class=\"index\">$gruppe</span><a name=\"$gruppe\"></a>\n";
        }
        $content .= "<a href=\"index.php?$wiki_get=$page\">$page</a>&nbsp;\n";
    }

    $indexstr = "<div class=\"index\">\n";
    foreach ( $index as $topic=>$dummy ) {
       $indexstr .= "<a href=\"#$topic\">$topic</a>&nbsp;\n";
    }
    $indexstr .= "</div>\n";

    $content = $indexstr . $content;

    return $content;
}





// format the WikiStyle to HTML
function filter($raw) {
    global $wiki_get, $name;
    global $ersetze,
           $page_ersetzung;
    global $print;
    global $incoming;
    global $page_uploadmanager;
    global $chatzeit;
    global $img_schauher, $csveditroutinen;

    global $typ, $action, $nr; // csvedit



    // galupki
    if ($_GET[$wiki_get]!=$page_ersetzung) {
       $raw = str_replace( $ersetze["search"], $ersetze["replace"], $raw ); // globales ersetzen
    }


    $filtered = stripslashes(htmlentities("\n\n".$raw));


    // php-specific
    $filtered = str_replace("\r\n","\n",$filtered);



    // galupki embedded sound / movie
    $filtered = preg_replace("/\[([ 0-9\w\_\.:\/\-%=\+\?]+\.(swf|wav|mp3|mov|avi|mpg|mpeg)):nostart\]/","<embed src=\"\\1\" class=\"wikiembed\" autostart=\"false\" loop=\"true\" title=\"\\1\"/>",$filtered);
    $filtered = preg_replace("/\[([ 0-9\w\_\.:\/\-%=\+\?]+\.(swf|wav|mp3|mov|avi|mpg|mpeg)):hidden\]/","<embed src=\"\\1\" class=\"wikiembed\" autostart=\"true\" hidden=\"true\" loop=\"true\" title=\"\\1\"/>",$filtered);
    $filtered = preg_replace("/\[([ 0-9\w\_\.:\/\-%=\+\?]+\.(swf|wav|mp3|mov|avi|mpg|mpeg))\]/","<embed src=\"\\1\" class=\"wikiembed\" autostart=\"true\" loop=\"true\" title=\"\\1\"/>",$filtered);


    // pictures [ url ]
    $filtered = preg_replace("/\[([\w\.:\/\-%=\+\?]+\.(png|gif|jpg))\]/","<img src=\"\\1\" class=\"wikiimage\" />",$filtered);


//  // [ url | link ] external links (original)
//  $filtered = preg_replace("/\[((http|ftp|https|mailto|file):\/\/[\w\.\:\@\?~\%=\+\-\/]+)\|([\w ]+)\]/i","<a href=\"\\1\">\\3</a>", $filtered);

    // galupki [ url | link ] external links
    $filtered = preg_replace("/\[((ftp|http|https|mailto|file):[^|]+)\|([^\]]+)\]/i",
                             "<a href=\"\\1\">\\3</a>",
                             $filtered);


    // plain urls in the text
    $filtered = preg_replace("/(?<![\"\[])(http|ftp|https|mailto|file):[\w\.:\/\%\-\+@=\?]+(?!\")/","<a href=\"\\0\">\\0</a>",$filtered);


    // the WikiWords
// look several lines below for another way of creating wiki pages
//  $filtered = preg_replace("/([A-Z][a-z0-9\;\&]+){2,}/","$img_schauher<a href=\"index.php?$wiki_get=\\0\">\\0</a>", $filtered);
    $filtered = preg_replace("/((?<!wiki=)[A-Z][a-z0-9\&]+){2,}/","$img_schauher<a href=\"index.php?$wiki_get=\\0\">\\0</a>", $filtered);


    // Headlines <h1><h2><h3>
    $filtered = preg_replace("/\n(!!!)(.+)\n/","</p>\n<h5>\\2</h5>\n<p>",$filtered);
    $filtered = preg_replace("/\n(!!)(.+)\n/","</p>\n<h3>\\2</h3>\n<p>",$filtered);
    $filtered = preg_replace("/\n(!)(.+)\n/","</p>\n<h2>\\2</h2>\n<p>",$filtered);

    // text decorations (bold,italic,underline,boxed)
    $filtered = preg_replace("/\*\*(.+)\*\*/U","<strong>\\1</strong>", $filtered);
    $filtered = preg_replace("/__(.+)__/U","<u>\\1</u>", $filtered);
    $filtered = preg_replace("/##(.+)##/U","<span class=\"small\">\\1</span>", $filtered); // galupki
    $filtered = preg_replace("/''(.+)''/U","<em>\\1</em>", $filtered);
    $filtered = preg_replace("/\|(.+)\|/U","<span class=\"box\">\\1</span>", $filtered);
    // horizontal lines
    $filtered = preg_replace("/\n---.*\n/","\n<hr class=\"wiki\"/>\n",$filtered);

    // lists <ul>
    $filtered = preg_replace("/(?<=[\n>])\* (.+)\n/","<li>\\1</li>",$filtered);
    $filtered = preg_replace("/<li>(.+)\<\/li>/","</p><ul>\\0</ul><p>",$filtered);

    // strip leading and ending line breaks
    $filtered = preg_replace("/^(\n+)/","",$filtered);
    $filtered = preg_replace("/\n{3,}/","\n\n",$filtered);

    // <pre> blocks
    $filtered = preg_replace("/(?<=\n) (.*)(\n)/","<pre>\\1</pre>", $filtered);

    // ad html line breaks <br />
    $filtered = str_replace("\n","<br />\n",$filtered);
    $filtered = str_replace("</pre><pre>","\n", $filtered);


    // create wiki pages with [brackets]
    // if you uncomment this line, you should comment the standard WikiWord line
    // this line makes words between such [ ] brackets a link to a wiki page
    // $filtered = preg_replace("/\[([\w]+)\]/","<a href=\"index.php?$wiki_get=\\1\">\\1</a>", $filtered);

    // insert specials, check it first to prevent useless execution of the functions
    if( strpos($filtered, "&lt;findpage&gt;") !== FALSE )
        $filtered = str_replace("&lt;findpage&gt;", findpage(), $filtered);
    if( strpos($filtered, "&lt;allpages&gt;") !== FALSE )
        $filtered = str_replace("&lt;allpages&gt;", allpages(), $filtered);
    if( strpos($filtered, "&lt;recentchanges&gt;") !== FALSE )
        $filtered = str_replace("&lt;recentchanges&gt;", recentchanges(), $filtered);


    // galupki - #mysql - Die folgenden beiden Seiten in Kommentar setzen falls kein MySQL genutzt werden soll
    if( strpos($filtered, "&lt;mysql&gt;") !== FALSE )
        $filtered = str_replace("&lt;mysql&gt;", mysqldata(), $filtered);

    // galupki - csvedit
    if( strpos($filtered, "&lt;csvedit&gt;") !== FALSE ) {
        require_once($csveditroutinen);
        $filtered = str_replace("&lt;csvedit&gt;", doCSV(basename($name), "$incoming"."csvedit.".basename($name).".csv", ""), $filtered);
    }
    // galupki - csvedit - aber Kalenderfile
    if( strpos($filtered, "&lt;csvedit:k&gt;") !== FALSE ) {
        require_once($csveditroutinen);
        $filtered = str_replace("&lt;csvedit:k&gt;", doCSV(basename($name), "$incoming"."csvedit.".basename($name).".csv", "k"), $filtered);
    }

    // galupki
    if( strpos($filtered, "&lt;locklist&gt;") !== FALSE )
        $filtered = str_replace("&lt;locklist&gt;", lock_list(), $filtered);
    if( strpos($filtered, "&lt;uploader&gt;") !== FALSE ) {
        $uplcontent = "";
        if ( !file_global_locked($page_uploadmanager."Upload") ) { // besonderheit!!!
           $uplcontent  .= upload_form();
        }

        $uplcontent .= upload_show_dir($incoming);

        $filtered = str_replace("&lt;uploader&gt;", $uplcontent, $filtered);
    }
    if( strpos($filtered, "&lt;chat&gt;") !== FALSE ) {
        $filtered = str_replace("&lt;chat&gt;", chat_form(), $filtered);
    }  else {
       $chatzeit = 0;
    }
    if( strpos($filtered, "&lt;importexport&gt;") !== FALSE ) {
        $filtered = str_replace("&lt;importexport&gt;", import_export_form(), $filtered);
    }


    // html beauty
    $filtered = str_replace("</li>","</li>\n",$filtered);
    $filtered = str_replace("ul>","ul>\n",$filtered);
    $filtered = str_replace("<br />\n<h","\n<h", $filtered);
    $filtered = preg_replace("/(<\/h[1-3]>)<br \/>\n/","\\1\n", $filtered);
    $filtered = str_replace("<p></p>","",$filtered);


    // galupki einfache TABLES
    $filtered = str_replace ("&lt;table&gt;",                                "\n<table border=\"0\">", $filtered);
    $filtered = str_replace ("&lt;td&gt;",                                   "<td class=\"tabfeld\">", $filtered);
    $filtered = preg_replace("/(&lt;td colspan=&quot;)([1-9])(&quot;&gt;)/", "<td class=\"tabfeld\" colspan=\"$2\">", $filtered);
    $filtered = preg_replace("/(&lt;)(\/table|\/tr|tr|\/td)(&gt;)/",         "<$2>", $filtered);
    // kann man das nachfolgende einfacher zusammenfassen???
    // Hier soll gngiger Schmutz zwischen Tabellenanweisungen entfernt werden...
    $filtered = preg_replace ("/(<table border=\"0\">)([\r\n]|<br \/>|<pre>|<\/pre>)*(<tr>)/", "\\1\n\\3", $filtered);
    $filtered = preg_replace ("/(<tr>)([\r\n]|<br \/>|<pre>|<\/pre>)*(<td)/",                  "\\1\n\\3", $filtered);
    $filtered = preg_replace ("/(<\/td>)([\r\n]|<br \/>|<pre>|<\/pre>)*(<\/tr>|<td)/",         "\\1\n\\3", $filtered);
    $filtered = preg_replace ("/(<\/tr>)([\r\n]|<br \/>|<pre>|<\/pre>)*(<tr>|<\/table>)/",     "\\1\n\\3", $filtered);



    return $filtered;
}


// the ONLY page output of this script!
function output($data, $file) {
 global $lockstring;
    $pagename = basename($file);
    $modified = "";
    if( file_exists($file) ) {
        $modified = date("H:i:s d.m.Y", filemtime($file));   // galupki formatstring
    }
    $data = str_replace("<!--wikiname-->",$pagename,$data);
    $data = str_replace("<!--lastmodified-->",$modified,$data);
    $data = str_replace("<!--lockstatus-->",$lockstring,$data); // galupki
    $data = str_replace("<!--chatstatus-->",chat_status(),$data); // galupki
    echo $data;
}


// get the page content
function showpage($file) {
    global $template_show, $css;
    global $wiki_get;
    global $name;
    global $freespace, $max_data_space;

    global $chatzeit, $chatter;


    $content = "";

    // get the wanted file
    $raw = implode("", file($file) );
    // but filter it !

    $content = filter( $raw ) . $content;

    // get the page template
    $template = implode( "", file($template_show) );
    $template = str_replace("fwiki.css",$css,$template);


    // #mysql galupki folgende zeilen mssen nicht unbedingt deaktiviert werden, haben aber nur Auswirkungen bei MySql-Einsatz in der Druckansicht
    $begriff = trim($_REQUEST["begriff"]);
    $mysql   = trim($_REQUEST["mysql"]);
    $template = str_replace("<!--mysql-->","&begriff=$begriff&mysql=$mysql",$template);


    $whole = str_replace("<!--wikicontent-->",$content."\n<!-- spaceinfo $max_data_space:$freespace -->\n",$template);
    if ( $chatzeit > 0 ) {
       $whole = str_replace("<!--wikichat-->","<meta http-equiv=\"refresh\" content=\"$chatzeit;URL=index.php?wiki=$name&chatter=$chatter\">",$whole);
    }
    output( $whole, $file );
}


// if we hace to edit a page
function editpage($file) {
    global $template_edit, $css, $edittool;

    $already = "";

    if( file_exists( $file ) )
        $already = implode( "", file( "$file" ) );

    if( file_exists( $template_edit ) )
        $template = file($template_edit);
    else
        echo "kein Template (".$template_edit.") gefunden!<br />\n";

    $template = implode( "", $template );
    $template = str_replace("fwiki.css",$css,$template);
    $template = str_replace("\$edittool",$edittool,$template);

    $whole =str_replace("<!--already-->",stripslashes($already),$template);

    // file could be locked
    if( file_exists($file)
        AND !is_writeable($file) ) // note the s modifier !
        $whole = preg_replace("/<form .*<\/form>/s","<h3>Sorry, Page is locked (not writeable)</h3>", $whole);

    output($whole, $file );
}



?>