<?php

// fwiki 1.0b (c) http://galupki.de/php.html#fwiki GPL, ergaenzende lizenzhinweise auf http://galupki.de/kontakt/
// siehe unbedingt auch Bemerkungen zu Beginn von index.php

// http://galupki.de     Jrgen Galupki



// bereinigen uneinheitlicher (Unix/Mac/Pc) Zeilenende
 if (isset($_POST["content"])) {
    $content   = $_POST["content"];
    $content = preg_replace("/\r\n|\r|\n/", "\n", $content);
 }


// globalisieren
 if (isset($_POST["swie"]))      $swie      = $_POST["swie"];
 if (isset($_POST["ersetze"]))   $ersetze   = $_POST["ersetze"];
 if (isset($_POST["grep"]))      $grep      = $_POST["grep"];
 if (isset($_POST["trtab"]))     $trtab     = $_POST["trtab"];
 if (isset($_POST["match"]))     $match     = $_POST["match"];
 if (isset($_POST["von"]))       $von       = $_POST["von"];
 if (isset($_POST["nach"]))      $nach      = $_POST["nach"];
 if (isset($_POST["funktion"]))  $funktion  = $_POST["funktion"];
 if (isset($_POST["fx"]))        $fx        = $_POST["fx"];
 if (isset($_POST["stxt"]))      $stxt      = $_POST["stxt"];



// ersetzen / grep

   if ( isset($grep) ) {
      $xarr = explode ("\n", $content);
      $yarr = @preg_grep("/".$von."/", $xarr);
      $content = @implode("\n", $yarr);
   }

   if ( isset($match) ) {
      $xarr = explode ("\n", $content);
      foreach ($xarr as $key => $val) {
         if (fnmatch($von, $val)) {
            $yarr[] = $val;
         }
      }
      $content = @implode("\n", $yarr);
   }

   if ( isset($ersetze) ) {
      $content = @preg_replace("/".$von."/", $nach, $content);
      $content = str_replace("\\n", "\n", $content);
   }

  if ( isset($trtab) ) {
      $content = strtr( $content, $von, $nach);
   }


// Sonderfunktionen
  if ( isset($funktion) ) {

     switch ($stxt) {
        case "md5":   $msg = "<strong>md5-hash:</strong> " . md5(trim($content));
             break;
        case "rot13": $content = str_rot13($content);
             break;
        case "qprt":  $content = quoted_printable_decode($content);
             break;
        case "stta":  $content = strip_tags($content);
             break;
        case "low":   $content = strtolower($content);
             break;
        case "upp":   $content = strtoupper($content);
             break;
        case "words": $content = ucwords($content);
             break;
        case "shuff": $content = zwirbel($content);
             break;
        case "rev":   $content = strrev($content);
             break;
        case "wrap":  if (is_numeric($fx)) $content = wordwrap($content, $fx, "\n");
             break;
        case "expl":  if ( isset($fx) ) {
                         $xarr = explode($fx, $content);
                         $content = "";
                         foreach ($xarr as $key => $val) {
                            $content .= $val."\n";
                         }
                      }
             break;
        case "impl":  if ( isset($fx) ) {
                         $xarr = explode("\n", $content);
                         $content = implode($fx, $xarr);
                      }
             break;
        default:
                      if ( $stxt==SORT_STRING
                           OR $stxt==SORT_NUMERIC ) {           // sortieren
                         if ( !isset($swie) ) {
                            $swie = "aufsteigend";
                         }
                         $xarr = explode ("\n", $content);
                         if (count($xarr)>0) {
                            switch ($swie) {
                               case "aufsteigend":  sort($xarr, $stxt);   break;
                               case "absteigend":   rsort($xarr, $stxt);  break;
                               case "natuerlichGK": natcasesort($xarr);   break;
                               default:             natsort($xarr);       break;
                            }
                            $content = rtrim(implode ("\n", $xarr)."\n");
                         }
                      }
                     break;
     } // end switch

  }



function zwirbel($text) {
// verzwirbelt text ;-) ab php 4.3.0

 srand ((double)microtime()*1000000);
 $new = $text;

 $words = str_word_count($text,2);   // zerlege in einzelne Worte

 if ( count($words)>0 ) {
    foreach ($words as $key => $val) {  // je Wort
       if ( strlen($val)>3 ) {          // das lnger als 3 Zeichen ist...
                                        // ersetze das innere durch eine verwrfelte Variante
          $new = substr_replace ( $new,
                                  substr($val,0,1)
                                  . str_shuffle(substr($val,1,strlen($val)-2))
                                  . substr($val, -1,1),
                                  $key,
                                  strlen($val)
                                );

       }
    }
 }

 return $new;

}





?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1">

<!--

http://galupki.de (c) 2003 Jrgen Galupki
Edit-Text-Tools 1.0b (ab php 4.3.0)

Achtung: Je nach Konfiguration von php kann es notwendig sein strip-/add-/slashes zu verwenden!


// -->

       <title>Edit-Text-Tools</title>
    </head>
    <body>
        <div id="title"><h2>Edit-Text-Tools</h2></div>
        <form method="post" action="edit-tools.php">
            <p>
            <input type="submit" name="ersetze" value="ersetze" /> &nbsp;
            <input type="submit" name="trtab" value="trtab" /> &nbsp;
            <input type="submit" name="grep" value="grep" /> &nbsp;
            <input type="submit" name="match" value="match" /> <br />
            <input type="text" name="von"  size="40" maxlength="250"       value="<?php echo $von; ?>" />
            durch
            <input type="text" name="nach" size="40" maxlength="250" value="<?php echo $nach; ?>" />
            </p>

            <p>
            <input type="submit" name="funktion" value="funktion" /> x =
            <input type="text" name="fx"  size="3" maxlength="3" value="<?php echo $fx; ?>" /> <br />
            <input type="Radio" name="stxt" value="md5"   <?php if ($stxt=="md5")   {echo "checked=\"checked\"";}; ?>> md5 hash &nbsp;
            <input type="Radio" name="stxt" value="rot13" <?php if ($stxt=="rot13") {echo "checked=\"checked\"";}; ?>> rot13 &nbsp;
            <input type="Radio" name="stxt" value="qprt"  <?php if ($stxt=="qprt")  {echo "checked=\"checked\"";}; ?>> decode quoted_printable &nbsp;
            <input type="Radio" name="stxt" value="stta"  <?php if ($stxt=="stta")  {echo "checked=\"checked\"";}; ?>> strip tags &nbsp; <br />
            <input type="Radio" name="stxt" value="wrap"  <?php if ($stxt=="wrap")  {echo "checked=\"checked\"";}; ?>> wordwrap nach x  &nbsp;
            <input type="Radio" name="stxt" value="expl"  <?php if ($stxt=="expl")  {echo "checked=\"checked\"";}; ?>> explode anhand x &nbsp;
            <input type="Radio" name="stxt" value="impl"  <?php if ($stxt=="impl")  {echo "checked=\"checked\"";}; ?>> implode mit x &nbsp; <br />
            <input type="Radio" name="stxt" value="low"   <?php if ($stxt=="low")   {echo "checked=\"checked\"";}; ?>> lower caps &nbsp;
            <input type="Radio" name="stxt" value="upp"   <?php if ($stxt=="upp")   {echo "checked=\"checked\"";}; ?>> upper caps &nbsp;
            <input type="Radio" name="stxt" value="words" <?php if ($stxt=="words") {echo "checked=\"checked\"";}; ?>> upper caps Wortanfang &nbsp; <br />
            <input type="Radio" name="stxt" value="shuff" <?php if ($stxt=="shuff") {echo "checked=\"checked\"";}; ?>> verzwirbeln &nbsp;
            <input type="Radio" name="stxt" value="rev"   <?php if ($stxt=="rev")   {echo "checked=\"checked\"";}; ?>> reverse &nbsp; <br />
            <strong>sort:</strong>
            <input type="Radio" name="stxt" value="<?php echo SORT_STRING; ?>"  <?php if ($stxt==SORT_STRING)  {echo "checked=\"checked\"";}; ?>> sort as string &nbsp;
            <input type="Radio" name="stxt" value="<?php echo SORT_NUMERIC; ?>" <?php if ($stxt==SORT_NUMERIC) {echo "checked=\"checked\"";}; ?>> sort numeric &nbsp; <br />
            <strong>options:</strong>
            <input type="Radio" name="swie" value="aufsteigend"  <?php if ($swie=="aufsteigend") {echo "checked=\"checked\"";}; ?>> aufsteigend &nbsp;
            <input type="Radio" name="swie" value="absteigend"   <?php if ($swie=="absteigend") {echo "checked=\"checked\"";}; ?>> absteigend &nbsp;
            <input type="Radio" name="swie" value="natuerlich"   <?php if ($swie=="natuerlich") {echo "checked=\"checked\"";}; ?>> natrlich &nbsp;
            <input type="Radio" name="swie" value="natuerlichGK" <?php if ($swie=="natuerlichGK") {echo "checked=\"checked\"";}; ?>> natrlich (ignore upper/lower caps) &nbsp; <br />
            </p>

            <p>
            <?php if (isset($msg)) echo $msg."<br />\n"; ?>
            <textarea name="content" cols="80" rows="20" wrap="soft"><?php echo $content; ?></textarea><br />
            <?php echo "[<strong>Worte:</strong> " . str_word_count($content) . "] [<strong>Zeichen:</strong> " . strlen($content) . "]" ;   ?>
            </p>
        </form>

        <ul id="footer" style="text-align: left;">
            <li>
            "Zurck-"Taste des Browsers macht letze(n) Schritt(e) rckgngig
            </li>
            <li>
            <strong>edit-tools 1.0b</strong> &nbsp;
            <a href="index.php?wiki=EditToolFenster">[Hilfe]</a> &nbsp;
            &copy; <a href="http://galupki.de">http://galupki.de</a>
            </li>
        </ul>
    </body>
</html>