<?php


// fwiki 1.0b (c) http://galupki.de/php.html#fwiki GPL, ergaenzende lizenzhinweise auf http://galupki.de/kontakt/
// siehe unbedingt auch Bemerkungen zu Beginn von index.php


/*
 $host = "";
 $db   = "";
 $user = "";
 $pw   = "";
*/

 require("/.../wiki/lock/wiki_ms.php"); // #mysql anpassen!!! <-----------------------

// ACHTUNG: besser als das Lockverzeichnis ist ein Verzeichnis, das nicht ber
// den Webserver zugreifbar ist!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


/*
# Tabellenstruktur fr Tabelle `wikidb`
#
CREATE TABLE wikidb (
  wiki varchar(10) NOT NULL default '',
  seite varchar(128) NOT NULL default '',
  begriff varchar(128) NOT NULL default '',
  bereich varchar(128) NOT NULL default '',
  datum timestamp(14) NOT NULL,
  text text NOT NULL,
  PRIMARY KEY  (wiki,seite,begriff),
  KEY datum (datum),
  KEY bereich (bereich)
) TYPE=MyISAM COMMENT='Wiki-Datenbank';

*/



/* ******************************************************************************************** */



// wandelt MySql-Datums-/Zeitstamp in ein lesbares Datum um
function mysqltime2german($t) {
    return sprintf("%02d.%02d.%04d %02d:%02d:%02dh",
                    substr($t, 6, 2),
                    substr($t, 4, 2),
                    substr($t, 0, 4),
                    substr($t, 8, 2),
                    substr($t, 10, 2),
                    substr($t, 12, 2));
}





// setzt Quotes um Feldinhalte und verdoppelt Semikolon bei Bedarf innerhalb von einzelnen Feldern
function csv_field($item) {
   $item = str_replace('"', '""', $item);
   if (strpos($item, ";") !== FALSE) {
     $item = '"' . $item . '"';
   } elseif (strpos($item, "\n") !== FALSE) {
     $item = '"' . $item . '"';
   }
   return $item;
}



// extrahieren einer kompletten Datenbank ins uploadverzeichnis
// Diese Datei heisst dann SeitenName.csv
function extractMysql($seite, $what) {

 global $host, $db, $user, $pw, $wiki;

 global $export_dir, $incoming, $upload_dir, $protfile;
 global $data_dir, $img_schauher, $page_uploadmanager;



 if (trim($what)=="") return "Suchmuster fehlt; es wurden keine Datenstze exportiert.";

 if ( file_global_locked($page_uploadmanager."Upload") ) {  // besonderheit!!!
    return "Der Uploadbereich ist derzeit gesperrt und kein Export dorthin mglich.";
 }


 $content =  "<h3>Datenexport</h3>";
 $content .= "Suchmuster: \"$what\".\n";
 $seite = basename($seite);


// ffne neu/zum fortschreiben
 if (file_exists($export_dir."$seite.csv")) {
    $whandle = fopen($export_dir."$seite.csv", "ab");
    $content .= "<p>Warnung: Die Exportdatei existiert schon und wird daher fortgeschrieben.</p>\n";
 } else {
    $whandle = fopen($export_dir."$seite.csv", "wb");
    fwrite($whandle, "Begriff;Bereich;Text;Datum\r\n");
 }


// Verbindungsaufbau
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }

 $what = str_replace ( "*", "%%", $what); // Jokerzeichen * ersetzen durch %
 $what = mysql_real_escape_string($what);
 $query = sprintf("select wiki,seite,begriff,bereich,text,datum from wikidb where wiki='$wiki' AND seite='$seite' AND begriff like '$what' order by begriff");
 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

 $zeilen = @mysql_num_rows($result);

 if ($zeilen>0) {
    while ($avar = mysql_fetch_array($result)) {
          fwrite($whandle,
                 csv_field($avar["begriff"]) . ";" .
                 csv_field($avar["bereich"]) . ";" .
                 csv_field($avar["text"])    . ";" .
                 csv_field($avar["datum"])   . "\r\n" );
    }
 }

 mysql_free_result($result);
 mysql_close($link);

 fclose($whandle);

 $content .= "<p>$zeilen Zeilen wurden exportiert nach Datei <strong>$seite.csv</strong>\n";
 if ($incoming==$export_dir) {
    upload_prot( "DatenBanken export", "$seite.csv", " " );
    $content .= " (ins $img_schauher<a href=\"index.php?wiki=UploadManager\">UploadManager</a> Verzeichnis).</p>\n";
 }  else {
    $content .= " ins Exportverzeichnis.</p>\n";
 }

 return $content;

} // end function export




// importieren einer CSV-Datei
function importMysql($seite, $what) {

 global $host, $db, $user, $pw, $wiki;

 global $export_dir, $incoming, $upload_dir;
 global $img_schauher;
 global $is_locked;


 if (trim($what)=="") return "Suchmuster fehlt; es wurden keine Datenstze importiert.";


 $content =  "<h3>Datenimport</h3>";
 $content .= "Suchmuster: \"$what\".\n";
 $seite = basename($seite);



 if ($is_locked) return "$content <p>$seite is locked!</p>\n";



// ffne zum lesen
 if (!file_exists($export_dir."$seite.csv")) {
    $content .= "<p>Fehler: Die Importdatei existiert nicht.</p>\n";

    return $content;     // <------------------------------

 } else {
    $whandle = fopen($export_dir."$seite.csv", "rb");
//    fwrite($whandle, "Begriff;Bereich;Text;Datum\r\n");
 }

 // Verbindungsaufbau
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }

 $what = mysql_real_escape_string($what);

 $treffer = 0;
 $row = 0;
 while ($data = fgetcsv ($whandle, filesize($export_dir."$seite.csv"), ";", "\"")) {
    $row++;
    if ( ( $row>1                                            // ab 2. Zeile
          OR (strtolower(trim($data[0]))!="begriff"))        // oder ohne berschrift
         AND fnmatch($what, $data[0])                        // und Suchmuster passt...
         AND trim($data[0]!="")) {
    // Datensatz bearbeiten

       $begriff = rtrim($data[0]);
       $bereich = rtrim($data[1]);
       $text    = rtrim($data[2]);                  // weitere Felder werden ignoriert

       $text = mysql_real_escape_string($text);
       $bereich = mysql_real_escape_string($bereich);
       $begriff = mysql_real_escape_string($begriff);
       $query = sprintf("INSERT INTO wikidb (wiki,seite,begriff,bereich,text) VALUES ('$wiki','$seite','$begriff','$bereich','$text')");

       $result = mysql_query($query, $link);
       if (!$result) {
//        print mysql_error();
          $content .= "<p>Fehler: Ein Datensatz \"$begriff\" aus Importdatei existiert bereits. Nicht eingefgt:<br />\n";
          $content .= "Bereich: $bereich<br />Text: $text</p>\n";
       }  else {
          $treffer++;
       }


    } // end if Datensatz bearbeiten

 } // end while Datensaetze


// mysql_free_result($result);
 mysql_close($link);
 fclose($whandle);

 $content .= "<p>$treffer Zeilen wurden importiert aus Datei <strong>$seite.csv</strong>\n";
 if ($incoming==$export_dir) {
    $content .= " (aus dem $img_schauher<a href=\"index.php?wiki=UploadManager\">UploadManager</a> Verzeichnis).</p>\n";
 }  else {
    $content .= " aus dem Exportverzeichnis.</p>\n";
 }

 return $content;

} // end function import




// (Massen)delete von Datenstzen
function deleteMysql($seite, $what) {

 global $host, $db, $user, $pw, $wiki;

 global $export_dir, $incoming, $upload_dir;
 global $img_schauher;
 global $is_locked;


 $what = trim($what);
 if (substr($what,0,1)!="!" or strlen($what)<2) return "<h3>Lschkennzeichen \"!\" oder Suchmuster fehlt, Aktion abgebrochen!</h3>\n";
 $what = substr($what, 1);

 $content =  "<h3>Datenstze lschen</h3>";
 $content .= "Suchmuster: \"$what\".\n";



 if ($is_locked) return "$content <p>$seite is locked!</p>\n";



 // Verbindungsaufbau
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }

 $what = str_replace ( "*", "%%", $what); // Jokerzeichen * ersetzen durch %
 $what = mysql_real_escape_string($what);

// $query = sprintf("DELETE FROM wikidb WHERE wiki='$wiki' AND seite='$seite' AND begriff=''");
// $result = mysql_query($query, $link);

 $query = sprintf("DELETE FROM wikidb WHERE wiki='$wiki' AND seite='$seite' AND begriff LIKE '$what'");
 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    $content .= "<p>Fehler: Lschen nicht ausgefhrt.</p>\n";
 }  else {
    $content .= "<p>Lschen ausgefhrt.</p>\n";
    $treffer = mysql_affected_rows();
    $content .= "<p>$treffer Stze bearbeitet.</p>";

 }

 mysql_close($link);

 return $content;

} // end function delete





//
function hideData($what) {

  return $what;
}




// zeigt den gerade gewnschten Inhalt der Datenbank an
function showMysql($seite, $what, &$actindex) {

 global $host, $db, $user, $pw, $wiki;
 global $img_dir, $img_schauher;


 $what = str_replace ( "*", "%%", trim($what)); // Jokerzeichen * ersetzen durch %

 $content = "";


 if ( isset($_REQUEST["sbegriff"])
      OR isset($_REQUEST["sbereich"])
      OR isset($_REQUEST["stext"])
      OR isset($_REQUEST["sdatum"]) ) {
    $begriffssuche = false;
 }  else {
    $begriffssuche = true;
 }

 if ($what=="") {
    $content .= "<h3>Kein Suchmuster angegeben.</h3>";
    return $content;
 }



// Verbindungsaufbau
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }


 $what = mysql_real_escape_string($what);

// indexsuche oder volltextsuche


// $query = sprintf("select wiki,seite,begriff,bereich,text,datum from wikidb where wiki='$wiki' AND seite='$seite' AND begriff like '$what' order by begriff");

 $query = sprintf("select wiki,seite,begriff,bereich,text,datum from wikidb where wiki='$wiki' AND seite='$seite' AND ( ");

 $anzq = 0;
 if ( (isset($_REQUEST["sbegriff"]) AND $_REQUEST["sbegriff"]==true ) OR $begriffssuche ) {
    $query .= sprintf("begriff like '$what' ");
    $anzq++;
 }
 if ( isset($_REQUEST["sbereich"]) AND $_REQUEST["sbereich"]==true ) {
    if ($anzq>0) $query .= "OR ";
    $query .= sprintf("bereich like '$what' ");
    $anzq++;
 }
 if ( isset($_REQUEST["stext"]) AND $_REQUEST["stext"]==true ) {
    if ($anzq>0) $query .= "OR ";
    $query .= sprintf("text like '$what' ");
    $anzq++;
 }
 if ( isset($_REQUEST["sdatum"]) AND $_REQUEST["sdatum"]==true ) {
    if ($anzq>0) $query .= "OR ";
    $query .= sprintf("datum like '$what' ");
    $anzq++;
 }

 $query .= sprintf(")");

 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

 $zeilen = @mysql_num_rows($result);
//printf("Das Ergebnis hat %d Zeilen.\n", $zeilen);
 while ($avar = mysql_fetch_array($result)) {
       if ($zeilen>1) {
          $actindex .= hideData($avar["begriff"]). ";";
       }

       $content .= "<div class=\"mysqlbox\"><h3><a name=\"" . $avar["begriff"] . "\">" . $avar["begriff"] . "</a>";
       if ( trim($avar["bereich"])!="" ) {
          $content .= " <span class=\"small\">(" . $avar["bereich"] . ")</span>";
       }
       $content .= "</h3>\n";

       $tmp     = filter($avar["text"]."\n");
       $tmp     = preg_replace( "/(!)([A-Za-z0-9]+)(!)/",
                                "$img_schauher<a href=\"index.php?wiki=$seite&mysql=\\2\">\\2</a>",
                                $tmp);

       $content .= $tmp . "\n<div class=\"small\">"
                .  " &nbsp;<br /><a href=\"index.php?wiki=$seite&amp;begriff=" . $avar["begriff"] . "&amp;mysql=update\"><img src=\"" . $img_dir . "zeigen.gif\" width=\"15\" height=\"15\" border=\"0\" alt=\"editieren\" title=\"editieren\"/></a> "
                .  " &nbsp;<a href=\"index.php?wiki=$seite&amp;begriff=" . $avar["begriff"] . "&amp;mysql=copy\"><img src=\"" . $img_dir . "copy.gif\" width=\"15\" height=\"15\" border=\"0\" alt=\"kopieren und editieren\" title=\"kopieren und editieren\"/></a> "
                .  mysqltime2german($avar["datum"])
                .  " <a href=\"#idx\">&uarr;</a></div></div>\n";
 }

 mysql_free_result($result);
 mysql_close($link);

 return $content;

}



// zeigt einen Index oder das Glossar oder die zuletzt genderten Stze oder alle Datenbanken des Wikis an
function showMysqlGlossar($seite, &$actindex, $typ) {

 global $host, $db, $user, $pw, $wiki;


// Verbindungsaufbau
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }


 if ($typ=="index") {
    $query = sprintf("select wiki,seite,begriff from wikidb where wiki='$wiki' AND seite='$seite' order by begriff");
 }  elseif ($typ=="glossar") {
    $query = sprintf("select wiki,seite,begriff,bereich from wikidb where wiki='$wiki' AND seite='$seite' order by bereich,begriff");
 }  elseif ($typ=="zuletzt") {
    $query = sprintf("select wiki,seite,begriff,datum from wikidb where wiki='$wiki' AND seite='$seite' order by datum DESC,begriff ASC LIMIT 50");
 }  else {
    $query = sprintf("select wiki,seite from wikidb where wiki='$wiki' group by seite");
 }

 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

//$zeilen = mysql_num_rows($result);
//printf("Das Ergebnis hat %d Zeilen.\n", $zeilen);

 $oldbereich = "";

 $content = "\n<h1>" . ucfirst($typ) . "</h1><div class=\"small\">";
 if ( $typ=="datenbanken" ) {
    $content .= mysqlSpace(true) . "\n<h4>...davon in diesem Wiki:</h4>";
 }

 while ($avar = mysql_fetch_array($result)) {
       if ( $typ=="glossar" ) {
          $bereich = $avar["bereich"];
       }  elseif ($typ=="index") {
          $bereich = substr($avar["begriff"],0,1);
       }  elseif ($typ=="zuletzt") {
          $bereich = substr(mysqltime2german($avar["datum"]),0,10);
       }  else {
          $bereich = $avar["seite"];
       }

       if ($oldbereich!=$bereich) {
          if ($typ!="datenbanken") {
             $content .= "<h3><a name=\"" . $bereich . "\">" . $bereich . "</a>"
                      .  " <a href=\"#idx\">&uarr;</a>"
                      .  "</h3>\n";
             $actindex .= hideData($bereich) . ";";
          }
          $oldbereich = hideData($bereich);
       }
       if ( $typ!="datenbanken" ) {
          if ($typ=="zuletzt") {
             $content .= substr(mysqltime2german($avar["datum"]),11,5) . "h ";
          }
          $content .= "<a href=\"index.php?wiki=$seite&amp;begriff=" . $avar["begriff"] . "\">"
                   .  $avar["begriff"] . "</a> &nbsp;<br />\n";
       }  else {
          $content .= "<a href=\"index.php?wiki=" . $avar["seite"] . "\">". $avar["seite"] ."</a> &nbsp;<br />\n";
       }
 }
 $content .= "</div>\n";

 mysql_free_result($result);
 mysql_close($link);

 return $content;

}


// eingabeformular fr neue und zu ndernde stze, lschen mglich
function modifyMysql($seite, $begriff) {

 global $mysql;
 global $host, $db, $user, $pw, $wiki;
 global $name, $wiki_get, $edittool;


 $aktion = "input";

// erstmal Daten holen falls vorhanden
 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }
 $begriff = mysql_real_escape_string($begriff);
 $query = sprintf("select wiki,seite,begriff,bereich,text from wikidb where wiki='$wiki' AND seite='$seite' AND begriff='$begriff' LIMIT 1");
 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

 $zeilen = mysql_num_rows($result);
 if ( $zeilen>0 ) {
    while ($avar = mysql_fetch_array($result)) {
       $oldbegriff = $avar["begriff"];
       $bereich = $avar["bereich"];
       $oldinhalt = $avar["text"];
       if ($mysql!="copy") {
          $aktion  = "update";
       }
    }
 }
 mysql_free_result($result);
 mysql_close($link);


 $content .= "<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php\">\n<input type=\"hidden\" name=\"$wiki_get\" value=\"$seite\" />"
          . "\n<input type=\"hidden\" name=\"oldbegriff\" value=\"$oldbegriff\" />\n"
          . "<table id=\"find\">\n"
          . "<tr><td colspan=\"2\"><input type=\"submit\" name=\"$aktion\" value=\"$aktion\" /> ";

 if ($aktion=="update") {
    $content .= "&nbsp; <input type=\"submit\" name=\"delete\" value=\"delete\" /><div class=\"small\"> <strong>Hinweis:</strong> Es lassen sich nur Eintrge lschen, wenn gleichzeitig das Textfeld geleert wird!</div></td></tr>\n";
 }  else {
    $content .= "</td></tr>\n";
 }

 $content .= "<tr>\n<td valign=\"top\"><b>Begriff</b></td><td><input type=\"text\" name=\"begriff\" size=\"80\" maxlength=\"128\" value=\"$begriff\" /></td>\n</tr>"
          . "<tr>\n<td valign=\"top\"><b>Bereich</b></td><td><input type=\"text\" name=\"bereich\" size=\"80\" maxlength=\"128\" value=\"$bereich\" /></td>\n</tr>"
          . "<tr>\n<td valign=\"top\">Auto-<br />Verlinkung</td><td><input type=\"checkbox\" name=\"autolink\" value=\"false\" /></td>\n</tr>"
          . "<tr>\n<td valign=\"top\"><b>Text</b></td><td><textarea name=\"text\" cols=\"80\" rows=\"10\" wrap=\"soft\">$oldinhalt</textarea></td>\n</tr>"
          . "\n</table>\n</form>\n";

 $content .=      ' <ul id="footer" style="text-align: left;">';
 $content .=      '     <li><a href="' . $edittool . '" target="edittool"><strong>Edit-Tool-Fenster aufmachen</strong></a>';
 $content .=      '         <a href="index.php?wiki=EditToolFenster" target="edittool">Hilfe zum EditToolFenster</a></li>';
 $content .=      '     <li>Ein * am Zeilenanfang erzeugt eine Aufzhlung</li>';
 $content .=      '     <li>Ein oder mehrere ! am Zeilenanfang erzeugen berschriften</li>';
 $content .=      '     <li>** um etwas <b>fett</b> zu formatieren</li>';
 $content .=      '     <li>__ zum <u>unterstreichen</u></li>';
 $content .=      '     <li>## fr <span class=small">kleine Schriftart</span></li>';
 $content .=      "     <li>'' <i>kursiv</i></li>";
 $content .=      '     <li>Einschliessen in | erzeugt eine <span style="box">Box</span></li>';
 $content .=      '     <li> Leerzeichen am Zeilenanfang fr preformatted Text</li>';
 $content .=      '     <li>upload# wird ersetzt durch den Pfad des Upload-Verzeichnisses (Ersetzungen!)</li>';
 $content .=      '     <li>!Begriff! verweist auf andere Datenbankeintrge</li>';
 $content .=      ' </ul>';

 return $content;

}



// prft wieviel Platz noch frei ist und setzt evtl. einen Vernderungslock...
function mysqlSpace($ausgabe) {
 global $host, $db, $user, $pw, $wiki;
 global $max_mysql_data_space;
 global $is_locked;


 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }

 $query = sprintf("SHOW TABLE STATUS LIKE 'wikidb'");

 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

 $content = "";

 $zeilen = mysql_num_rows($result);
 if ( $zeilen>0 ) {
    while ($avar = mysql_fetch_array($result)) {
       $content .= "<br /><strong>".$avar[Comment];
//     $content .= "</strong>, Table ".$avar[Name];
       $content .= "</strong> enthlt ".$avar[Rows] . " Zeilen";
       $content .= " mit jeweils durchschnittlich ".$avar[Avg_row_length]." Bytes Lnge.";
       $content .= "<br />Data ". round($avar[Data_length]/1000,3)." KBytes";
       $content .= " + Index ". round($avar[Index_length]/1000,3). " KBytes";

       $summe = ($avar[Data_length]+$avar[Index_length]);
       $prozent = round($summe * 100 / $max_mysql_data_space,2);

       $content .= " = <strong>". round($summe/1000,3) ." KBytes</strong> belegt";
       $content .= " ($prozent % des zugewiesenen Bereichs).\n";
    }
 }
 mysql_free_result($result);
 mysql_close($link);

 if ($prozent>100) {
    $is_locked = true;
    $content .= "<h3>nderungen an der DB sind gesperrt (Speicherplatz)</h3>\n";
 }  elseif (!$ausgabe) {
    $content =  "<br /><strong>". round($summe/1000,3) ." KBytes</strong> belegt";
    $content .= " ($prozent % des im lokalen Wiki zugewiesenen Bereichs).\n";
 }

 return $content;

}




// setzt automatisch "!" um gefundene Begriffe die nicht so gekennzeichnet sind!
// ist natrlich nur bei kleineren Datenbanken sinnvoll (noch keine Abfrage) klappt auch nicht richtig
function autoVerlinkung($seite, $txt) {

//return $txt;           // kommentar entfernen zum "deaktivieren" bei Laufzeitproblemen

 global $host, $db, $user, $pw, $wiki;


// erzeugen einer Wortliste aus dem Text
 $wl = preg_split("/ |\n|\.|\,|\!|\?|\;|\%|\+|\&/", $txt, -1, PREG_SPLIT_OFFSET_CAPTURE); //davor: Trenner blank oder newline
 if ( count($wl)>0 ) {
    foreach ($wl as $item) {
       if (strlen(trim($item[0]))>4) { // wortlnge > 4 Zeichen
          $et[$item[0]] = $item[1];    // merken mit position
       }
    }
 }

// falls worte zu berprfen sind
 if ( count($et)>0 ) {

    arsort($et, SORT_NUMERIC);         // von hinten nach vorne

    $link = mysql_connect($host, $user, $pw);
    if (!$link) {
       return ("Kann den MySQL-Server $host nicht erreichen.");
    }
    if (!mysql_select_db($db, $link)) {
       return ("Kann die Datenbank auf $host nicht anwhlen.");
    }

    foreach ($et as $wort=>$position) {
//     $what = mysql_real_escape_string($wort."%%");
       $what = mysql_real_escape_string($wort);
//     $query = sprintf("select wiki,seite,begriff from wikidb where wiki='$wiki' AND seite='$seite' AND begriff LIKE '$what'");
       $query = sprintf("select wiki,seite,begriff from wikidb where wiki='$wiki' AND seite='$seite' AND begriff='$what'");
       $result = mysql_query($query, $link);
       if (!$result) {
          print mysql_error();
          return ("Query $query ist ungltiges SQL.");
       }
       $zeilen = mysql_num_rows($result);
       if ($zeilen>0
           AND substr($txt, max(0,$position-1),1)!="!" ) {                    // Treffer in der Datenbank!
          $txt = substr($txt, 0, $position) . "!" . $wort . "!" . substr($txt, $position+strlen($wort));
       }
    }

    mysql_free_result($result);
    mysql_close($link);
 }


 return $txt;

}




// fhrt insert, update, delete tatschlich in der DB aus
function todoMysql($action, $seite, $begriff) {


 global $host, $db, $user, $pw, $wiki;
 global $name, $wiki_get;
 global $is_locked;


 $begriff = rtrim($begriff);
 $bereich = rtrim($_POST["bereich"]);
 $text    = rtrim($_POST["text"]);
 $oldbegriff = rtrim($_POST["oldbegriff"]);
 $autolink = $_POST["autolink"];


 if ( trim($begriff)==""
      OR trim($wiki)==""
      OR trim($seite)==""
      OR ( $action=="delete" AND strlen($text)>3) ) {
    return "<p>$action ($seite, $begriff) wurde nicht ausgefhrt.</p>";
 }


 // DB-Sperre wg. Speicherplatzberschreitung?
 if ($is_locked) return "<p>$seite is locked.</p>";

 $content = mysqlSpace(false);
 if ( $is_locked AND $action!="delete" ) {
    return $content;
 }


// automatische Verschlagwortung
 if ($action!="delete"
     AND $autolink==true) {
    $text = autoVerlinkung($seite, $text);
 }

 $link = mysql_connect($host, $user, $pw);
 if (!$link) {
    return ("Kann den MySQL-Server $host nicht erreichen.");
 }
 if (!mysql_select_db($db, $link)) {
    return ("Kann die Datenbank auf $host nicht anwhlen.");
 }

 if ($action=="delete") {
    $begriff = mysql_real_escape_string(str_replace("%", "\%", $begriff));
    $begriff = mysql_real_escape_string($begriff);
    $query = ("DELETE FROM wikidb WHERE wiki='$wiki' AND seite='$seite' AND begriff='$begriff' LIMIT 1");
 }  elseif ($action=="update") {
    $oldbegriff = mysql_real_escape_string($oldbegriff);
    $text = mysql_real_escape_string(str_replace("%", "\%", $text));
    $bereich = mysql_real_escape_string(str_replace("%", "\%", $bereich));
    $begriff = mysql_real_escape_string(str_replace("%", "\%", $begriff));
    if (strtolower($oldbegriff)==strtolower($begriff)) {
       $query = ("UPDATE wikidb SET text='$text',bereich='$bereich' WHERE wiki='$wiki' AND seite='$seite' AND begriff='$begriff' LIMIT 1");
    }  else {
       $query = ("INSERT INTO wikidb (wiki,seite,begriff,bereich,text) VALUES ('$wiki','$seite','$begriff','$bereich','$text')");
       $result = mysql_query($query, $link);
       if (!$result) {
          print mysql_error();
          return ("Query $query ist ungltiges SQL.");
       }
       $query = ("DELETE FROM wikidb WHERE wiki='$wiki' AND seite='$seite' AND begriff='$oldbegriff' LIMIT 1");
    }
 }  elseif ($action=="input") {
    $text = mysql_real_escape_string(str_replace("%", "\%", $text));
    $bereich = mysql_real_escape_string(str_replace("%", "\%", $bereich));
    $begriff = mysql_real_escape_string(str_replace("%", "\%", $begriff));
    $query = ("INSERT INTO wikidb (wiki,seite,begriff,bereich,text) VALUES ('$wiki','$seite','$begriff','$bereich','$text')");
 }

 $result = mysql_query($query, $link);
 if (!$result) {
    print mysql_error();
    return ("Query $query ist ungltiges SQL.");
 }

 mysql_close($link);

 return "$content\n<p>$action fr $begriff wurde ausgefhrt.</p>\n";

}



// zeigt Men und ruft gewnschte Ausgabe auf bzw. verteilt anzustehende Aufgaben!
function mysqldata() {

 global $alphabet;
 global $name, $wiki_get, $img_dir;
 global $mysql;
 global $is_locked;


  $seite = basename($name);
  $actindex = "";
  $sqldaten = "";
  $treffer  = "";

  $begriff = $_REQUEST["begriff"];
  $mysql   = $_REQUEST["mysql"];


  // input update delete zu bearbeiten?
  if (!$is_locked) {
// nur wenn nicht gesperrt!
     if ( isset($_POST["delete"]) ) {
        $sqldaten .= todoMysql("delete", $seite, $begriff);
     }  elseif ( isset($_POST["update"]) ) {
        $sqldaten .= todoMysql("update", $seite, $begriff);
     }  elseif ( isset($_POST["input"]) ) {
        $sqldaten .= todoMysql("input", $seite, $begriff);
     }
  }


  // darzustellender inhalt

  if ( $mysql=="update" AND !$is_locked ) {
     $sqldaten .= modifyMysql($seite, $begriff);
  }  elseif ( $mysql=="copy" AND !$is_locked ) {
     $sqldaten .= modifyMysql($seite, $begriff);
  }  elseif (strtolower($mysql)=="glossar" OR strtolower($mysql)=="index"
             OR strtolower($mysql)=="zuletzt" OR strtolower($mysql)=="datenbanken") {
     $sqldaten .= showMysqlGlossar($seite, $actindex, strtolower($mysql));
  }  elseif ( strtolower($mysql)=="export" ) {
     $sqldaten .= extractMysql($seite, $begriff);
  }  elseif ( strtolower($mysql)=="import" ) {
     $sqldaten .= importMysql($seite, $begriff);
  }  elseif ( strtolower($mysql)=="delete" ) {
     $sqldaten .= deleteMysql($seite, $begriff);
  }  elseif ( trim($begriff)!="" ) {                               // suchen
     $sqldaten .= showMysql($seite, trim($begriff), $actindex);
  }  elseif ( trim($mysql)!="" ) {
     $sqldaten .= showMysql($seite, trim($mysql)."%%", $actindex );
  }

  $content  = "<a name=\"idx\"></a><table width=\"94%\" border=\"0\">\n";
  $content .= "<tr><td width=\"65%\" valign=\"top\" class=\"small\">\n";

  if ($actindex!="") {
     $index = explode(";", $actindex);
     foreach ($index as $item) {
        $content .= "<a href=\"#$item\">$item</a> <br />\n";
     }
     $treffer = "(".((count($index))-1).")";
  }  elseif ( $begriff=="" AND $mysql=="" ) {
     $content .= "<p>ready.</p>\n";
  }

  $content .= "</td>\n";


  if ( !isset($_REQUEST["print"])
       OR $_REQUEST["print"]==False) {
     // Menue anzeigen
     $content .= "<td width=\"35%\" valign=\"top\">";
     $content .= "<span class=\"mymenue\"><form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php\">\n";

     $content .= "<a href=\"index.php?wiki=$seite&amp;mysql=index\">[Index]</a> &nbsp; \n";
     $content .= "<a href=\"index.php?wiki=$seite&amp;mysql=glossar\">[Glossar]</a> &nbsp; \n";
     $content .= "<a href=\"index.php?wiki=$seite&amp;mysql=zuletzt\">[Zuletzt]</a> &nbsp; \n";
     if (!$is_locked) {
        $content .= "<a href=\"index.php?wiki=$seite&amp;begriff=&amp;mysql=update\">[Neu]</a> &nbsp; \n";
     }
     $content .= "<a href=\"index.php?wiki=DatenBanken\">[?]</a><br /> &nbsp;<br />\n";
     for ($i=0; $i<strlen($alphabet); $i++) {
         $x = substr($alphabet, $i, 1);
         $content .= "<a href=\"index.php?wiki=$seite&amp;mysql=$x\">$x</a> \n";
     }
     $content .= "<input type=\"hidden\" name=\"$wiki_get\" value=\"$seite\" />"
              . "<table id=\"find\">\n<tr>\n<td>"
              . "<span class=\"small\">"
              . "<input type=\"text\" name=\"begriff\" size=\"25\" maxlength=\"255\" value=\"$begriff\" /> \n"

              . "<input type=\"submit\" name=\"mysql\" value=\"suchen\" /> in<br />\n"
              . "Begriff <input type=\"checkbox\" name=\"sbegriff\" value=\"true\" checked=\"checked\"/> "
              . "Bereich <input type=\"checkbox\" name=\"sbereich\" value=\"true\" /> "
              . "<em>Text</em> <input type=\"checkbox\" name=\"stext\"    value=\"true\" /> "
              . "Datum <input type=\"checkbox\" name=\"sdatum\"   value=\"true\" /> "

              . "<br />"
              . "<input type=\"submit\" name=\"mysql\" value=\"export\" /> ";

     if (!$is_locked) {
        $content .= "<input type=\"submit\" name=\"mysql\" value=\"import\" /> "
                 . "<input type=\"submit\" name=\"mysql\" value=\"delete\" /> &nbsp; (alle nur via Begriff) &nbsp; ";
     }
     $content .= "<a href=\"index.php?wiki=$seite&amp;begriff=&amp;mysql=datenbanken\">[...]</a> &nbsp; \n"
              . "</span></td>\n</tr>"
              . "\n</table>\n";
   //$content .= "$treffer";
     $content .= "</span>\n</form>\n";
     $content .= "</td>\n";
  }

  $content .= "</tr></table>\n";

  $content .= $sqldaten;

  return $content;

}


?>