<?php

// fwiki 1.0b (c) http://galupki.de/php.html#fwiki GPL, ergaenzende lizenzhinweise auf http://galupki.de/kontakt/
// siehe unbedingt auch Bemerkungen zu Beginn von index.php

/*

Lizenz http://www.gnu.org/licenses/translations.html

This program is free software; you can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem
Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version.
Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.


*/



/*

fwiki basiert in seinem Ursprung auf dem Script fr TipiWiki2:

http://tipiwiki.sourceforge.net

Author: Andreas Zwinkau
eMail: andi@buxach.de
Date: 14/6/2003
Description: A small, simple, standard-compliant wiki-system
Licence: GPL, do i need to say any more?


Die Unterschiede/Weiterentwicklungen sind ganz gut auf der WikiPage
"WikiHistory" beschrieben.

*/




// ****************************************************************************************************************


// ++++++++ NO CHANGES BELOW HERE ! ++++++++
//       (unless you are a developer)


$routinen = "";
$mysqlroutinen = "";

require("setup.php");
require($routinen);
require($mysqlroutinen);    // #mysql evtl. in Kommentar setzen wenn keine MySQL-DB verwendet wird



// if ( PHP version < 4.1 ) $_GET is not available!
$version_info = explode('.', phpversion());
if ($version_info[0] < 4 || ($version_info[0] > 3 && $version_info[1] < 1)) {
        $_POST = $HTTP_POST_VARS;
        $_GET = $HTTP_GET_VARS;
}



// initialization galupki *****************************************************************************************

// ersetzungen
$ersetze[]      = "";
if (file_exists("$data_dir/$page_ersetzung")) {
    $handle = @fopen("$data_dir/$page_ersetzung","r");
    while ($line = @fgetcsv ($handle, 255, " ") ) {

       $anz = count($line);
       for ( $i=2; $i<=$anz; $i++) {
           if (substr( $line[$i],0,2)=="//") {
              break;
           }
           $line[1] .= " ".trim($line[$i]);
       }
       if (trim($line[0])!=""
           AND substr($line[0],0,2)!="//") {
          $ersetze["search"][]  = trim($line[0]);
          $ersetze["replace"][] = trim($line[1]);
       }
    }
    @fclose($handle);
}


// file locking
$lock       = basename($_REQUEST["lock"]);
$unlock     = basename($_REQUEST["unlock"]);
$lockliste  = $_REQUEST["lockliste"];
$lastpage   = $_REQUEST["lastpage"];
if ( file_exists($global_lockfile) ) {
   $handle = fopen($global_lockfile, "r");
   while ($data = fgetcsv ($handle, 255, ";")) {
      $locked[] = trim($data[0]);                  // enthaelt die Namen der global gesperrten Seiten und oder ALL
   }
   fclose ($handle);
   unset($locked[0]); // berschriftenzeile
}  else {
   $locked[] = "";
}


// uploadmanager
$upldel        = basename($_REQUEST["upldel"]);
$erweiterungen = explode(",", $endungen);
sort($erweiterungen);


// chat
if (isset($_REQUEST["chatter"])) {
   $chatter = $_REQUEST["chatter"];
}



// galupki basic lock logik
if ( trim($lock)!="" ) {
// lock a file
   if (!file_locked($lock)
       AND $is_locked==false) {
      lock_file($lock);
   }
   $lastpage = $lock;
}
if ( trim($unlock)!="" ) {
// unlock a file
   if (file_locked($unlock)
       AND $is_locked==false) {
      unlock_file($unlock);
   }
   $lastpage = $unlock;
}
if ( $lockliste=="liste" ) {
// display locking list
   lock_list();              // delete files kein Problem - geht nur wenn Files leer sind
}


// galupki basic uploader *********************************************************************************
if ( $upldel!="" ) {
   upload_delete($upldel);  // delete kann via UploadManagerUpload gesperrt werden
}



// **********************************************************************************************************





$edit = False;
$name = "$data_dir/$page_default";



if ( isset( $_POST[$wiki_get] ) ) {       // bad&dirty galupki
   $_GET[$wiki_get] = $_POST[$wiki_get];
}


if( isset( $_GET[$wiki_get] ) )
    $name = "$data_dir/".$_GET[$wiki_get];
// Now we know the name of the current page



// galupki lock status akt. Seite
$lockname = basename($name);
if ( file_locked($lockname) ) {
   $is_locked = true;
   $lockstring = "<a href=\"index.php?wiki=".$_GET[$wiki_get]."&amp;unlock=$lockname\">" . $img_unlocked . "</a>";
}  else {
   if ( file_global_locked ($lockname) ) {
      $is_locked = true;
      $lockstring = "<a href=\"index.php?wiki=GlobalLocked\">" . $img_unlocked . " (global locked) </a>";
   }  else {
      $lockstring = "<a href=\"index.php?wiki=".$_GET[$wiki_get]."&amp;lock=$lockname\">" . $img_locked . "</a>";
   }
}



// write possible stuff from a edit session
if( $is_locked == false
    AND isset($_POST["content"]) ) {

// galupki max_space reached ?
    $freespace = $max_data_space - dataspace() - strlen($_POST["content"]);
    if ( $freespace < 0 ) {
       $is_locked = true;
       $lockstring = "<a href=\"index.php?wiki=SpaceLimit\">" . $img_unlocked . " (<strong>space limit</strong>) </a>";
    }  else {
       $data = rtrim($_POST["content"])."\n";
       $handle = fopen("$name",'w');
       if( ! fwrite($handle, $data ) ) {
           $data_perm = decoct(fileperms($name)) % 1000;
           $data_owner = (fileowner($name));
           $data_group = (filegroup($name));
           die("Error writing Data into $name ( it has permissions $data_perm  and is owned by $data_owner:$data_group) !");
       }
       fclose($handle);
    }
    edit_unlock();  // galupki

// redirect (editpage)
    redirectpage( $name );
    return;

}



if( ! file_exists( "$name" ) )
    $edit = True;
if( $_GET["edit"] == "True"
    AND $is_locked==false                   // galupki
//    AND !file_locked($lockname)           // galupki
//    AND !file_global_locked($lockname)    // galupki
    AND !edit_locked() )                  // galupki
    $edit = True;



// force reload [ by hybrid-2k (Fabio Pereira) ]
header ("Expires: Mon, 26 Jul 1990 05:00:00 GMT");
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header ("Cache-Control: no-cache, must-revalidate");
header ("Pragma: no-cache");




// shall we edit or just show it?


if ( $print ) {
   $template_show = $template_read;
   showpage ( $name );
} elseif ( $edit ) {
    editpage( $name );
} else {
    showpage( $name );
}





?>